#include "1Cv8Operations.h"
#include <Web/Web.h>

v8Operations::v8Operations(){
	Sizeable(true);
	v8dt_unpack <<= THISBACK(V8dt_unpack);
	CtrlLayout(*this, "1Cv8 file opertations");
};

void v8Operations::V8dt_unpack(){
	if(!UnpackToFile(FileSave.GetData().ToString()))
		PromptOK("Cannot Unpack!");
	else
		PromptOK("Unpacked successful!");
};

bool v8Operations::UnpackToFile(const char *filename){
	FileIn filedata(FileOpen.GetData().ToString());
	FileOut file_out_data(filename);
	const int64 size_total = filedata.GetSize()-9;
	// Verific header
	filedata.Seek(0);
	if (!filedata.Get(9).IsEqual("1CIBDmpF1"))
		return false;
	filedata.Seek(9);
	if(
		(ZDecompress(file_out_data, filedata, (int)filedata.GetLeft(), false, true)==-1)
		||(file_out_data.IsError()))
		return false;
	int64 test = file_out_data.GetSize();
	file_out_data.Close();
	return true;
}

GUI_APP_MAIN{
	v8Operations().Run();
}

